]>
Commit | Line | Data |
---|---|---|
f2352877 | 1 | #!/bin/bash |
0777eafb WD |
2 | # Tool mainly for U-Boot Quality Assurance: build one or more board |
3 | # configurations with minimal verbosity, showing only warnings and | |
4 | # errors. | |
eca3aeb3 WD |
5 | # |
6 | # SPDX-License-Identifier: GPL-2.0+ | |
0777eafb | 7 | |
d8e392d9 MF |
8 | usage() |
9 | { | |
10 | # if exiting with 0, write to stdout, else write to stderr | |
11 | local ret=${1:-0} | |
12 | [ "${ret}" -eq 1 ] && exec 1>&2 | |
13 | cat <<-EOF | |
14 | Usage: MAKEALL [options] [--] [boards-to-build] | |
15 | ||
16 | Options: | |
17 | -a ARCH, --arch ARCH Build all boards with arch ARCH | |
18 | -c CPU, --cpu CPU Build all boards with cpu CPU | |
19 | -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR | |
20 | -s SOC, --soc SOC Build all boards with soc SOC | |
4d1584bd | 21 | -b BOARD, --board BOARD Build all boards with board name BOARD |
7f79c6f2 | 22 | -l, --list List all targets to be built |
9b96c6b1 MV |
23 | -m, --maintainers List all targets and maintainer email |
24 | -M, --mails List all targets and all affilated emails | |
33f336d5 | 25 | -C, --check Enable build checking |
08510204 JH |
26 | -n, --continue Continue (skip boards already built) |
27 | -r, --rebuild-errors Rebuild any boards that errored | |
d8e392d9 MF |
28 | -h, --help This help output |
29 | ||
30 | Selections by these options are logically ANDed; if the same option | |
31 | is used repeatedly, such selections are ORed. So "-v FOO -v BAR" | |
32 | will select all configurations where the vendor is either FOO or | |
33 | BAR. Any additional arguments specified on the command line are | |
34 | always build additionally. See the boards.cfg file for more info. | |
35 | ||
36 | If no boards are specified, then the default is "powerpc". | |
37 | ||
38 | Environment variables: | |
39 | BUILD_NCPUS number of parallel make jobs (default: auto) | |
40 | CROSS_COMPILE cross-compiler toolchain prefix (default: "") | |
47104c37 | 41 | CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for |
93e14596 WD |
42 | architecture "ARCH". Substitute "ARCH" for any |
43 | supported architecture (default: "") | |
d8e392d9 MF |
44 | MAKEALL_LOGDIR output all logs to here (default: ./LOG/) |
45 | BUILD_DIR output build directory (default: ./) | |
f588bb03 | 46 | BUILD_NBUILDS number of parallel targets (default: 1) |
d8e392d9 MF |
47 | |
48 | Examples: | |
49 | - build all Power Architecture boards: | |
50 | MAKEALL -a powerpc | |
51 | MAKEALL --arch powerpc | |
52 | MAKEALL powerpc | |
53 | - build all PowerPC boards manufactured by vendor "esd": | |
54 | MAKEALL -a powerpc -v esd | |
55 | - build all PowerPC boards manufactured either by "keymile" or "siemens": | |
56 | MAKEALL -a powerpc -v keymile -v siemens | |
57 | - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards: | |
58 | MAKEALL -c mpc83xx -v freescale 4xx | |
59 | EOF | |
60 | exit ${ret} | |
61 | } | |
62 | ||
4d1584bd MY |
63 | SHORT_OPTS="ha:c:v:s:b:lmMCnr" |
64 | LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors" | |
0777eafb WD |
65 | |
66 | # Option processing based on util-linux-2.13/getopt-parse.bash | |
67 | ||
071bc923 | 68 | # Note that we use `"$@"' to let each command-line parameter expand to a |
0777eafb WD |
69 | # separate word. The quotes around `$@' are essential! |
70 | # We need TEMP as the `eval set --' would nuke the return value of | |
71 | # getopt. | |
72 | TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \ | |
73 | -n 'MAKEALL' -- "$@"` | |
74 | ||
d8e392d9 | 75 | [ $? != 0 ] && usage 1 |
0777eafb WD |
76 | |
77 | # Note the quotes around `$TEMP': they are essential! | |
78 | eval set -- "$TEMP" | |
79 | ||
80 | SELECTED='' | |
7f79c6f2 | 81 | ONLY_LIST='' |
9b96c6b1 MV |
82 | PRINT_MAINTS='' |
83 | MAINTAINERS_ONLY='' | |
08510204 JH |
84 | CONTINUE='' |
85 | REBUILD_ERRORS='' | |
0777eafb WD |
86 | |
87 | while true ; do | |
88 | case "$1" in | |
89 | -a|--arch) | |
90 | # echo "Option ARCH: argument \`$2'" | |
91 | if [ "$opt_a" ] ; then | |
92 | opt_a="${opt_a%)} || \$2 == \"$2\")" | |
93 | else | |
94 | opt_a="(\$2 == \"$2\")" | |
95 | fi | |
96 | SELECTED='y' | |
97 | shift 2 ;; | |
98 | -c|--cpu) | |
99 | # echo "Option CPU: argument \`$2'" | |
100 | if [ "$opt_c" ] ; then | |
aa2e279d | 101 | opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)" |
0777eafb | 102 | else |
aa2e279d | 103 | opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)" |
0777eafb WD |
104 | fi |
105 | SELECTED='y' | |
106 | shift 2 ;; | |
107 | -s|--soc) | |
108 | # echo "Option SoC: argument \`$2'" | |
109 | if [ "$opt_s" ] ; then | |
27af930e | 110 | opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)" |
0777eafb | 111 | else |
27af930e | 112 | opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)" |
0777eafb WD |
113 | fi |
114 | SELECTED='y' | |
115 | shift 2 ;; | |
116 | -v|--vendor) | |
117 | # echo "Option VENDOR: argument \`$2'" | |
118 | if [ "$opt_v" ] ; then | |
119 | opt_v="${opt_v%)} || \$5 == \"$2\")" | |
120 | else | |
121 | opt_v="(\$5 == \"$2\")" | |
122 | fi | |
123 | SELECTED='y' | |
124 | shift 2 ;; | |
4d1584bd MY |
125 | -b|--board) |
126 | # echo "Option BOARD: argument \`$2'" | |
127 | if [ "$opt_b" ] ; then | |
128 | opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")" | |
129 | else | |
130 | # We need to check the 7th field too | |
131 | # for boards whose 6th field is "-" | |
132 | opt_b="(\$6 == \"$2\" || \$7 == \"$2\")" | |
133 | fi | |
134 | SELECTED='y' | |
135 | shift 2 ;; | |
33f336d5 KP |
136 | -C|--check) |
137 | CHECK='C=1' | |
138 | shift ;; | |
08510204 JH |
139 | -n|--continue) |
140 | CONTINUE='y' | |
141 | shift ;; | |
142 | -r|--rebuild-errors) | |
143 | REBUILD_ERRORS='y' | |
144 | shift ;; | |
7f79c6f2 MV |
145 | -l|--list) |
146 | ONLY_LIST='y' | |
147 | shift ;; | |
9b96c6b1 MV |
148 | -m|--maintainers) |
149 | ONLY_LIST='y' | |
150 | PRINT_MAINTS='y' | |
151 | MAINTAINERS_ONLY='y' | |
152 | shift ;; | |
153 | -M|--mails) | |
154 | ONLY_LIST='y' | |
155 | PRINT_MAINTS='y' | |
156 | shift ;; | |
d8e392d9 MF |
157 | -h|--help) |
158 | usage ;; | |
0777eafb WD |
159 | --) |
160 | shift ; break ;; | |
161 | *) | |
162 | echo "Internal error!" >&2 ; exit 1 ;; | |
163 | esac | |
164 | done | |
e18fd940 MY |
165 | |
166 | GNU_MAKE=$(scripts/show-gnu-make) || { | |
167 | echo "GNU Make not found" >&2 | |
168 | exit 1 | |
169 | } | |
170 | ||
0777eafb WD |
171 | # echo "Remaining arguments:" |
172 | # for arg do echo '--> '"\`$arg'" ; done | |
173 | ||
94ab8f41 MY |
174 | tools/genboardscfg.py || { |
175 | echo "Failed to generate boards.cfg" >&2 | |
176 | exit 1 | |
177 | } | |
bb6da87d | 178 | |
0777eafb WD |
179 | FILTER="\$1 !~ /^#/" |
180 | [ "$opt_a" ] && FILTER="${FILTER} && $opt_a" | |
181 | [ "$opt_c" ] && FILTER="${FILTER} && $opt_c" | |
182 | [ "$opt_s" ] && FILTER="${FILTER} && $opt_s" | |
183 | [ "$opt_v" ] && FILTER="${FILTER} && $opt_v" | |
4d1584bd | 184 | [ "$opt_b" ] && FILTER="${FILTER} && $opt_b" |
0777eafb WD |
185 | |
186 | if [ "$SELECTED" ] ; then | |
27af930e | 187 | SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg) |
cd57b0bb PT |
188 | |
189 | # Make sure some boards from boards.cfg are actually found | |
190 | if [ -z "$SELECTED" ] ; then | |
191 | echo "Error: No boards selected, invalid arguments" | |
192 | exit 1 | |
193 | fi | |
0777eafb WD |
194 | fi |
195 | ||
196 | ######################################################################### | |
197 | ||
40a28f08 PT |
198 | # Print statistics when we exit |
199 | trap exit 1 2 3 15 | |
200 | trap print_stats 0 | |
201 | ||
7fa6a2f3 WD |
202 | # Determine number of CPU cores if no default was set |
203 | : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"} | |
204 | ||
205 | if [ "$BUILD_NCPUS" -gt 1 ] | |
206 | then | |
55f786d8 | 207 | JOBS="-j $((BUILD_NCPUS + 1))" |
7fa6a2f3 WD |
208 | else |
209 | JOBS="" | |
210 | fi | |
211 | ||
f9328639 MB |
212 | if [ "${MAKEALL_LOGDIR}" ] ; then |
213 | LOG_DIR=${MAKEALL_LOGDIR} | |
214 | else | |
215 | LOG_DIR="LOG" | |
216 | fi | |
887e2ec9 | 217 | |
f588bb03 AF |
218 | : ${BUILD_NBUILDS:=1} |
219 | BUILD_MANY=0 | |
220 | ||
221 | if [ "${BUILD_NBUILDS}" -gt 1 ] ; then | |
222 | BUILD_MANY=1 | |
223 | : ${BUILD_DIR:=./build} | |
224 | mkdir -p "${BUILD_DIR}/ERR" | |
225 | find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} + | |
f9328639 MB |
226 | fi |
227 | ||
f588bb03 AF |
228 | : ${BUILD_DIR:=.} |
229 | ||
230 | OUTPUT_PREFIX="${BUILD_DIR}" | |
231 | ||
232 | [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1 | |
08510204 JH |
233 | if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then |
234 | find "${LOG_DIR}/" -type f -exec rm -f {} + | |
235 | fi | |
7ebf7443 WD |
236 | |
237 | LIST="" | |
238 | ||
40a28f08 PT |
239 | # Keep track of the number of builds and errors |
240 | ERR_CNT=0 | |
241 | ERR_LIST="" | |
b86a475c JH |
242 | WRN_CNT=0 |
243 | WRN_LIST="" | |
40a28f08 | 244 | TOTAL_CNT=0 |
08510204 | 245 | SKIP_CNT=0 |
f588bb03 AF |
246 | CURRENT_CNT=0 |
247 | OLDEST_IDX=1 | |
f2352877 | 248 | RC=0 |
40a28f08 | 249 | |
9ec49f8f | 250 | # Helper funcs for parsing boards.cfg |
8948794a | 251 | targets_by_field() |
9ec49f8f | 252 | { |
8e5a2d42 MY |
253 | field=$1 |
254 | regexp=$2 | |
255 | ||
256 | awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \ | |
257 | boards.cfg | |
9ec49f8f | 258 | } |
8e5a2d42 | 259 | |
8948794a MY |
260 | targets_by_arch() { targets_by_field 2 "$@" ; } |
261 | targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; } | |
262 | targets_by_soc() { targets_by_field 4 "$@" ; } | |
9ec49f8f | 263 | |
0db5bca8 WD |
264 | ######################################################################### |
265 | ## MPC5xx Systems | |
266 | ######################################################################### | |
267 | ||
8948794a | 268 | LIST_5xx="$(targets_by_cpu mpc5xx)" |
0db5bca8 | 269 | |
945af8d7 WD |
270 | ######################################################################### |
271 | ## MPC5xxx Systems | |
272 | ######################################################################### | |
273 | ||
8948794a | 274 | LIST_5xxx="$(targets_by_cpu mpc5xxx)" |
945af8d7 | 275 | |
8993e54b RJ |
276 | ######################################################################### |
277 | ## MPC512x Systems | |
278 | ######################################################################### | |
279 | ||
8948794a | 280 | LIST_512x="$(targets_by_cpu mpc512x)" |
945af8d7 | 281 | |
7ebf7443 WD |
282 | ######################################################################### |
283 | ## MPC8xx Systems | |
284 | ######################################################################### | |
9ec49f8f | 285 | |
8948794a | 286 | LIST_8xx="$(targets_by_cpu mpc8xx)" |
7ebf7443 WD |
287 | |
288 | ######################################################################### | |
289 | ## PPC4xx Systems | |
290 | ######################################################################### | |
291 | ||
8948794a | 292 | LIST_4xx="$(targets_by_cpu ppc4xx)" |
7ebf7443 | 293 | |
7ebf7443 | 294 | ######################################################################### |
7aa78614 | 295 | ## MPC8260 Systems (includes 8250, 8255 etc.) |
7ebf7443 WD |
296 | ######################################################################### |
297 | ||
8948794a | 298 | LIST_8260="$(targets_by_cpu mpc8260)" |
7ebf7443 | 299 | |
f046ccd1 EL |
300 | ######################################################################### |
301 | ## MPC83xx Systems (includes 8349, etc.) | |
302 | ######################################################################### | |
303 | ||
8948794a | 304 | LIST_83xx="$(targets_by_cpu mpc83xx)" |
f046ccd1 | 305 | |
42d1f039 WD |
306 | ######################################################################### |
307 | ## MPC85xx Systems (includes 8540, 8560 etc.) | |
308 | ######################################################################### | |
309 | ||
8948794a | 310 | LIST_85xx="$(targets_by_cpu mpc85xx)" |
42d1f039 | 311 | |
822d5536 JL |
312 | ######################################################################### |
313 | ## MPC86xx Systems | |
314 | ######################################################################### | |
315 | ||
8948794a | 316 | LIST_86xx="$(targets_by_cpu mpc86xx)" |
822d5536 | 317 | |
d9a42c0a WD |
318 | ######################################################################### |
319 | ## PowerPC groups | |
320 | ######################################################################### | |
321 | ||
322 | LIST_TSEC=" \ | |
323 | ${LIST_83xx} \ | |
324 | ${LIST_85xx} \ | |
325 | ${LIST_86xx} \ | |
326 | " | |
327 | ||
a47a12be | 328 | LIST_powerpc=" \ |
fb56579f | 329 | ${LIST_5xx} \ |
3deca9d4 | 330 | ${LIST_512x} \ |
fb56579f KP |
331 | ${LIST_5xxx} \ |
332 | ${LIST_8xx} \ | |
fb56579f KP |
333 | ${LIST_824x} \ |
334 | ${LIST_8260} \ | |
335 | ${LIST_83xx} \ | |
336 | ${LIST_85xx} \ | |
337 | ${LIST_86xx} \ | |
338 | ${LIST_4xx} \ | |
fb56579f | 339 | " |
7ebf7443 | 340 | |
a47a12be SR |
341 | # Alias "ppc" -> "powerpc" to not break compatibility with older scripts |
342 | # still using "ppc" instead of "powerpc" | |
343 | LIST_ppc=" \ | |
344 | ${LIST_powerpc} \ | |
345 | " | |
346 | ||
7ebf7443 WD |
347 | ######################################################################### |
348 | ## StrongARM Systems | |
349 | ######################################################################### | |
350 | ||
8948794a | 351 | LIST_SA="$(targets_by_cpu sa1100)" |
7ebf7443 | 352 | |
cce5d210 AM |
353 | ######################################################################### |
354 | ## ARM7 Systems | |
355 | ######################################################################### | |
356 | ||
8948794a | 357 | LIST_ARM7="$(targets_by_cpu arm720t)" |
cce5d210 | 358 | |
7ebf7443 WD |
359 | ######################################################################### |
360 | ## ARM9 Systems | |
361 | ######################################################################### | |
362 | ||
8948794a MY |
363 | LIST_ARM9="$(targets_by_cpu arm920t) \ |
364 | $(targets_by_cpu arm926ejs) \ | |
365 | $(targets_by_cpu arm946es) \ | |
6f21347d | 366 | " |
7ebf7443 | 367 | |
8ed96046 WD |
368 | ######################################################################### |
369 | ## ARM11 Systems | |
370 | ######################################################################### | |
8948794a MY |
371 | LIST_ARM11="$(targets_by_cpu arm1136) \ |
372 | $(targets_by_cpu arm1176) \ | |
cce5d210 | 373 | " |
8ed96046 | 374 | |
f904cdbb | 375 | ######################################################################### |
f56348af | 376 | ## ARMV7 Systems |
f904cdbb | 377 | ######################################################################### |
f37586bb | 378 | |
8948794a | 379 | LIST_ARMV7="$(targets_by_cpu armv7)" |
f904cdbb | 380 | |
2475e634 DF |
381 | ######################################################################### |
382 | ## ARMV8 Systems | |
383 | ######################################################################### | |
384 | ||
385 | LIST_ARMV8="$(targets_by_cpu armv8)" | |
386 | ||
602cac13 JCPV |
387 | ######################################################################### |
388 | ## AT91 Systems | |
389 | ######################################################################### | |
390 | ||
8948794a | 391 | LIST_at91="$(targets_by_soc at91)" |
602cac13 | 392 | |
7ebf7443 WD |
393 | ######################################################################### |
394 | ## Xscale Systems | |
395 | ######################################################################### | |
396 | ||
8948794a | 397 | LIST_pxa="$(targets_by_cpu pxa)" |
7ebf7443 | 398 | |
24dede48 SR |
399 | ######################################################################### |
400 | ## SPEAr Systems | |
401 | ######################################################################### | |
402 | ||
8948794a | 403 | LIST_spear="$(targets_by_soc spear)" |
24dede48 | 404 | |
d9a42c0a WD |
405 | ######################################################################### |
406 | ## ARM groups | |
407 | ######################################################################### | |
2d5b561e | 408 | |
2475e634 DF |
409 | LIST_arm="$(targets_by_arch arm | \ |
410 | for ARMV8_TARGET in $LIST_ARMV8; \ | |
411 | do sed "/$ARMV8_TARGET/d"; \ | |
412 | done) \ | |
413 | " | |
7ebf7443 | 414 | |
c021880a | 415 | ######################################################################### |
b62bdffb | 416 | ## MIPS Systems (default = big endian) |
c021880a WD |
417 | ######################################################################### |
418 | ||
ed638b6a | 419 | LIST_mips="$(targets_by_arch mips)" |
c021880a | 420 | |
deddf5d2 SK |
421 | ######################################################################### |
422 | ## OpenRISC Systems | |
423 | ######################################################################### | |
424 | ||
8948794a | 425 | LIST_openrisc="$(targets_by_arch openrisc)" |
b62bdffb | 426 | |
7a8e9bed | 427 | ######################################################################### |
fea25720 | 428 | ## x86 Systems |
7a8e9bed WD |
429 | ######################################################################### |
430 | ||
8948794a | 431 | LIST_x86="$(targets_by_arch x86)" |
7a8e9bed | 432 | |
5c952cf0 WD |
433 | ######################################################################### |
434 | ## Nios-II Systems | |
435 | ######################################################################### | |
436 | ||
8948794a | 437 | LIST_nios2="$(targets_by_arch nios2)" |
5c952cf0 | 438 | |
857cad37 WD |
439 | ######################################################################### |
440 | ## MicroBlaze Systems | |
441 | ######################################################################### | |
442 | ||
8948794a | 443 | LIST_microblaze="$(targets_by_arch microblaze)" |
857cad37 | 444 | |
f8c3b4f3 ZL |
445 | ######################################################################### |
446 | ## ColdFire Systems | |
447 | ######################################################################### | |
448 | ||
8948794a | 449 | LIST_m68k="$(targets_by_arch m68k)" |
c13f47b0 | 450 | LIST_coldfire=${LIST_m68k} |
f8c3b4f3 | 451 | |
6ccec449 WD |
452 | ######################################################################### |
453 | ## AVR32 Systems | |
454 | ######################################################################### | |
455 | ||
8948794a | 456 | LIST_avr32="$(targets_by_arch avr32)" |
6ccec449 | 457 | |
ef26a08f AL |
458 | ######################################################################### |
459 | ## Blackfin Systems | |
460 | ######################################################################### | |
461 | ||
8948794a | 462 | LIST_blackfin="$(targets_by_arch blackfin)" |
ef26a08f | 463 | |
c7144373 JCPV |
464 | ######################################################################### |
465 | ## SH Systems | |
466 | ######################################################################### | |
467 | ||
8948794a MY |
468 | LIST_sh2="$(targets_by_cpu sh2)" |
469 | LIST_sh3="$(targets_by_cpu sh3)" | |
470 | LIST_sh4="$(targets_by_cpu sh4)" | |
d9a42c0a | 471 | |
8948794a | 472 | LIST_sh="$(targets_by_arch sh)" |
c7144373 | 473 | |
c2f02da2 DH |
474 | ######################################################################### |
475 | ## SPARC Systems | |
476 | ######################################################################### | |
477 | ||
8948794a | 478 | LIST_sparc="$(targets_by_arch sparc)" |
7ebf7443 | 479 | |
5f1719c1 ML |
480 | ######################################################################### |
481 | ## NDS32 Systems | |
482 | ######################################################################### | |
483 | ||
8948794a | 484 | LIST_nds32="$(targets_by_arch nds32)" |
5f1719c1 | 485 | |
568c1fad AB |
486 | ######################################################################### |
487 | ## ARC Systems | |
488 | ######################################################################### | |
489 | ||
490 | LIST_arc="$(targets_by_arch arc)" | |
491 | ||
7ebf7443 WD |
492 | #----------------------------------------------------------------------- |
493 | ||
9b96c6b1 MV |
494 | get_target_location() { |
495 | local target=$1 | |
496 | local BOARD_NAME="" | |
497 | local CONFIG_NAME="" | |
498 | local board="" | |
499 | local vendor="" | |
500 | ||
501 | # Automatic mode | |
23d6410c | 502 | local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` |
9b96c6b1 MV |
503 | if [ -z "${line}" ] ; then echo "" ; return ; fi |
504 | ||
505 | set ${line} | |
506 | ||
bb6da87d | 507 | CONFIG_NAME="${7%_defconfig}" |
9b96c6b1 | 508 | |
bb6da87d | 509 | [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}" |
9b96c6b1 | 510 | |
27af930e AA |
511 | if [ $# -gt 5 ]; then |
512 | if [ "$6" = "-" ] ; then | |
513 | board=${BOARD_NAME} | |
514 | else | |
515 | board="$6" | |
516 | fi | |
9b96c6b1 MV |
517 | fi |
518 | ||
519 | [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5" | |
27af930e AA |
520 | [ $# -gt 6 ] && [ "$8" != "-" ] && { |
521 | tmp="${8%:*}" | |
9b96c6b1 MV |
522 | if [ "$tmp" ] ; then |
523 | CONFIG_NAME="$tmp" | |
524 | fi | |
525 | } | |
526 | ||
527 | # Assign board directory to BOARDIR variable | |
27af930e | 528 | if [ "${vendor}" == "-" ] ; then |
9b96c6b1 MV |
529 | BOARDDIR=${board} |
530 | else | |
531 | BOARDDIR=${vendor}/${board} | |
532 | fi | |
533 | ||
27af930e | 534 | echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}" |
9b96c6b1 MV |
535 | } |
536 | ||
537 | get_target_maintainers() { | |
27af930e | 538 | local name=`echo $1 | cut -d : -f 3` |
9b96c6b1 | 539 | |
23d6410c | 540 | local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` |
27af930e | 541 | if [ -z "${line}" ]; then |
9b96c6b1 MV |
542 | echo "" |
543 | return ; | |
544 | fi | |
545 | ||
27af930e AA |
546 | local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'` |
547 | [ "$mails" == "-" ] && mails="" | |
548 | echo "$mails" | |
9b96c6b1 MV |
549 | } |
550 | ||
47104c37 AM |
551 | get_target_arch() { |
552 | local target=$1 | |
553 | ||
554 | # Automatic mode | |
54d1f504 | 555 | local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` |
47104c37 AM |
556 | |
557 | if [ -z "${line}" ] ; then echo "" ; return ; fi | |
558 | ||
559 | set ${line} | |
560 | echo "$2" | |
561 | } | |
562 | ||
9b96c6b1 MV |
563 | list_target() { |
564 | if [ "$PRINT_MAINTS" != 'y' ] ; then | |
565 | echo "$1" | |
566 | return | |
567 | fi | |
568 | ||
569 | echo -n "$1:" | |
570 | ||
571 | local loc=`get_target_location $1` | |
572 | ||
573 | if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi | |
574 | ||
575 | local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"` | |
576 | ||
577 | if [ "$MAINTAINERS_ONLY" != 'y' ] ; then | |
578 | ||
579 | local dir=`echo ${loc} | cut -d ":" -f 2` | |
580 | local cfg=`echo ${loc} | cut -d ":" -f 1` | |
581 | local git_result=`git log --format=%aE board/${dir} \ | |
582 | include/configs/${cfg}.h | grep "@"` | |
583 | local git_result_recent=`echo ${git_result} | tr " " "\n" | \ | |
584 | head -n 3` | |
585 | local git_result_top=`echo ${git_result} | tr " " "\n" | \ | |
586 | sort | uniq -c | sort -nr | head -n 3 | \ | |
587 | sed "s/^ \+[0-9]\+ \+//"` | |
588 | ||
589 | echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \ | |
590 | sort -u | tr "\n" " " | sed "s/ $//" ; | |
591 | else | |
592 | echo -e "$maintainers_result" | sort -u | tr "\n" " " | \ | |
593 | sed "s/ $//" ; | |
594 | fi | |
595 | ||
596 | echo "" | |
597 | } | |
598 | ||
f588bb03 AF |
599 | # Each finished build will have a file called ${donep}${n}, |
600 | # where n is the index of the build. Each build | |
601 | # we've already noted as finished will have ${skipp}${n}. | |
602 | # The code managing the build process will use this information | |
603 | # to ensure that only BUILD_NBUILDS builds are in flight at once | |
604 | donep="${LOG_DIR}/._done_" | |
605 | skipp="${LOG_DIR}/._skip_" | |
606 | ||
c97d59cb JH |
607 | build_target_killed() { |
608 | echo "Aborted $target build." | |
609 | # Remove the logs for this board since it was aborted | |
610 | rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR | |
611 | exit | |
612 | } | |
613 | ||
7ebf7443 WD |
614 | build_target() { |
615 | target=$1 | |
f588bb03 AF |
616 | build_idx=$2 |
617 | ||
f50bf50d AF |
618 | if [ "$ONLY_LIST" == 'y' ] ; then |
619 | list_target ${target} | |
620 | return | |
621 | fi | |
622 | ||
f588bb03 AF |
623 | if [ $BUILD_MANY == 1 ] ; then |
624 | output_dir="${OUTPUT_PREFIX}/${target}" | |
625 | mkdir -p "${output_dir}" | |
c97d59cb | 626 | trap build_target_killed TERM |
f588bb03 AF |
627 | else |
628 | output_dir="${OUTPUT_PREFIX}" | |
629 | fi | |
630 | ||
47104c37 | 631 | target_arch=$(get_target_arch ${target}) |
c17b94ec | 632 | eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'` |
47104c37 | 633 | if [ "${cross_toolchain}" ] ; then |
e18fd940 | 634 | MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}" |
47104c37 | 635 | elif [ "${CROSS_COMPILE}" ] ; then |
e18fd940 | 636 | MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}" |
47104c37 | 637 | else |
e18fd940 | 638 | MAKE=$GNU_MAKE |
47104c37 AM |
639 | fi |
640 | ||
9e414032 MY |
641 | if [ "${output_dir}" != "." ] ; then |
642 | MAKE="${MAKE} O=${output_dir}" | |
643 | fi | |
644 | ||
fd18a89e | 645 | ${MAKE} mrproper >/dev/null |
bb6da87d MY |
646 | |
647 | echo "Building ${target} board..." | |
648 | ${MAKE} -s ${target}_defconfig >/dev/null | |
f9328639 | 649 | |
33f336d5 | 650 | ${MAKE} ${JOBS} ${CHECK} all \ |
f588bb03 | 651 | >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR |
f2352877 PT |
652 | |
653 | # Check for 'make' errors | |
654 | if [ ${PIPESTATUS[0]} -ne 0 ] ; then | |
655 | RC=1 | |
656 | fi | |
657 | ||
e71796a7 JH |
658 | OBJS=${output_dir}/u-boot |
659 | if [ -e ${output_dir}/spl/u-boot-spl ]; then | |
660 | OBJS="${OBJS} ${output_dir}/spl/u-boot-spl" | |
661 | fi | |
662 | ||
663 | ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG | |
664 | ||
f588bb03 | 665 | if [ $BUILD_MANY == 1 ] ; then |
c97d59cb JH |
666 | trap - TERM |
667 | ||
7390643f | 668 | ${MAKE} -s clean |
f588bb03 AF |
669 | |
670 | if [ -s ${LOG_DIR}/${target}.ERR ] ; then | |
b86a475c | 671 | cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target} |
f588bb03 AF |
672 | else |
673 | rm ${LOG_DIR}/${target}.ERR | |
674 | fi | |
40a28f08 | 675 | else |
f588bb03 | 676 | if [ -s ${LOG_DIR}/${target}.ERR ] ; then |
b86a475c JH |
677 | if grep -iw error ${LOG_DIR}/${target}.ERR ; then |
678 | : $(( ERR_CNT += 1 )) | |
679 | ERR_LIST="${ERR_LIST} $target" | |
680 | else | |
681 | : $(( WRN_CNT += 1 )) | |
682 | WRN_LIST="${WRN_LIST} $target" | |
683 | fi | |
f588bb03 AF |
684 | else |
685 | rm ${LOG_DIR}/${target}.ERR | |
686 | fi | |
40a28f08 PT |
687 | fi |
688 | ||
f588bb03 AF |
689 | [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR" |
690 | ||
f588bb03 | 691 | touch "${donep}${build_idx}" |
7ebf7443 | 692 | } |
f588bb03 AF |
693 | |
694 | manage_builds() { | |
695 | search_idx=${OLDEST_IDX} | |
f50bf50d AF |
696 | if [ "$ONLY_LIST" == 'y' ] ; then return ; fi |
697 | ||
f588bb03 AF |
698 | while true; do |
699 | if [ -e "${donep}${search_idx}" ] ; then | |
f588bb03 AF |
700 | : $(( CURRENT_CNT-- )) |
701 | [ ${OLDEST_IDX} -eq ${search_idx} ] && | |
702 | : $(( OLDEST_IDX++ )) | |
703 | ||
704 | # Only want to count it once | |
705 | rm -f "${donep}${search_idx}" | |
706 | touch "${skipp}${search_idx}" | |
707 | elif [ -e "${skipp}${search_idx}" ] ; then | |
708 | [ ${OLDEST_IDX} -eq ${search_idx} ] && | |
709 | : $(( OLDEST_IDX++ )) | |
710 | fi | |
f588bb03 AF |
711 | : $(( search_idx++ )) |
712 | if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then | |
f588bb03 AF |
713 | if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then |
714 | search_idx=${OLDEST_IDX} | |
715 | sleep 1 | |
716 | else | |
717 | break | |
718 | fi | |
719 | fi | |
720 | done | |
721 | } | |
722 | ||
9ec49f8f MF |
723 | build_targets() { |
724 | for t in "$@" ; do | |
725 | # If a LIST_xxx var exists, use it. But avoid variable | |
726 | # expansion in the eval when a board name contains certain | |
727 | # characters that the shell interprets. | |
728 | case ${t} in | |
729 | *[-+=]*) list= ;; | |
730 | *) list=$(eval echo '${LIST_'$t'}') ;; | |
731 | esac | |
732 | if [ -n "${list}" ] ; then | |
733 | build_targets ${list} | |
734 | else | |
f588bb03 AF |
735 | : $((TOTAL_CNT += 1)) |
736 | : $((CURRENT_CNT += 1)) | |
737 | rm -f "${donep}${TOTAL_CNT}" | |
738 | rm -f "${skipp}${TOTAL_CNT}" | |
08510204 JH |
739 | if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then |
740 | : $((SKIP_CNT += 1)) | |
741 | touch "${donep}${TOTAL_CNT}" | |
742 | elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then | |
743 | : $((SKIP_CNT += 1)) | |
744 | touch "${donep}${TOTAL_CNT}" | |
b594bd6a | 745 | else |
08510204 JH |
746 | if [ $BUILD_MANY == 1 ] ; then |
747 | build_target ${t} ${TOTAL_CNT} & | |
748 | else | |
749 | CUR_TGT="${t}" | |
750 | build_target ${t} ${TOTAL_CNT} | |
751 | CUR_TGT='' | |
752 | fi | |
b594bd6a | 753 | fi |
f588bb03 AF |
754 | fi |
755 | ||
756 | # We maintain a running count of all the builds we have done. | |
757 | # Each finished build will have a file called ${donep}${n}, | |
758 | # where n is the index of the build. Each build | |
759 | # we've already noted as finished will have ${skipp}${n}. | |
760 | # We track the current index via TOTAL_CNT, and the oldest | |
761 | # index. When we exceed the maximum number of parallel builds, | |
762 | # We look from oldest to current for builds that have completed, | |
763 | # and update the current count and oldest index as appropriate. | |
764 | # If we've gone through the entire list, wait a second, and | |
765 | # reprocess the entire list until we find a build that has | |
766 | # completed | |
767 | if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then | |
768 | manage_builds | |
9ec49f8f MF |
769 | fi |
770 | done | |
771 | } | |
7ebf7443 WD |
772 | |
773 | #----------------------------------------------------------------------- | |
774 | ||
f50bf50d | 775 | kill_children() { |
6bdd9f89 AB |
776 | local OS=$(uname -s) |
777 | local children="" | |
778 | case "${OS}" in | |
779 | "Darwin") | |
780 | # Mac OS X is known to have BSD style ps | |
781 | local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d") | |
782 | children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d") | |
783 | ;; | |
784 | *) | |
785 | # everything else tries the GNU style | |
786 | local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ') | |
787 | children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d") | |
788 | ;; | |
789 | esac | |
c97d59cb JH |
790 | |
791 | kill $children 2> /dev/null | |
792 | wait $children 2> /dev/null | |
f50bf50d AF |
793 | |
794 | exit | |
795 | } | |
796 | ||
40a28f08 | 797 | print_stats() { |
7f79c6f2 | 798 | if [ "$ONLY_LIST" == 'y' ] ; then return ; fi |
f588bb03 | 799 | |
c97d59cb JH |
800 | # Only count boards that completed |
801 | : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`)) | |
802 | ||
f588bb03 AF |
803 | rm -f ${donep}* ${skipp}* |
804 | ||
805 | if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then | |
033220e7 | 806 | ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/` |
b86a475c JH |
807 | ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done` |
808 | ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'` | |
033220e7 | 809 | WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/` |
b86a475c JH |
810 | WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done` |
811 | WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'` | |
c97d59cb JH |
812 | else |
813 | # Remove the logs for any board that was interrupted | |
814 | rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR | |
f588bb03 AF |
815 | fi |
816 | ||
08510204 | 817 | : $((TOTAL_CNT -= ${SKIP_CNT})) |
40a28f08 PT |
818 | echo "" |
819 | echo "--------------------- SUMMARY ----------------------------" | |
08510204 JH |
820 | if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then |
821 | echo "Boards skipped: ${SKIP_CNT}" | |
822 | fi | |
40a28f08 PT |
823 | echo "Boards compiled: ${TOTAL_CNT}" |
824 | if [ ${ERR_CNT} -gt 0 ] ; then | |
b86a475c JH |
825 | echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )" |
826 | fi | |
827 | if [ ${WRN_CNT} -gt 0 ] ; then | |
828 | echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )" | |
40a28f08 PT |
829 | fi |
830 | echo "----------------------------------------------------------" | |
f2352877 | 831 | |
f50bf50d | 832 | if [ $BUILD_MANY == 1 ] ; then |
c97d59cb | 833 | kill_children |
f50bf50d AF |
834 | fi |
835 | ||
f2352877 | 836 | exit $RC |
40a28f08 | 837 | } |
7ebf7443 | 838 | |
40a28f08 | 839 | #----------------------------------------------------------------------- |
9ec49f8f | 840 | |
0777eafb WD |
841 | # Build target groups selected by options, plus any command line args |
842 | set -- ${SELECTED} "$@" | |
843 | # run PowerPC by default | |
9ec49f8f | 844 | [ $# = 0 ] && set -- powerpc |
9ec49f8f | 845 | build_targets "$@" |
f588bb03 | 846 | wait |